/*  This file is `NOT' GNU, error report to stderr library routines.

    Copyright (C) 1993-95  씎Y(oo) <HGG00736@niftyserve.or.jp>
*/
#include	<stdio.h>
#include	<ctype.h>
#include	<errno.h>
#ifdef	__STDC__
#include	<stdlib.h>
#include	<stdarg.h>
#else
#include	<varargs.h>
#endif
#ifdef	HAVE_CONFIG_H
#include	"config.h"
#endif
#include	"error.h"

static char*	progname = NULL;


/*FUNC
char*	DEFUN(set_progname, (pathname), char* pathname)
	pathname	vOopXl[

@\	pXȂǂvOԂ
		܂Å֐Ăяoƈȍ~́Ãt@C̊֐Q
		vObZ[W擪ɕt

	pathname ͕ύX\
ENDFUNC*/
char*	DEFUN(set_progname, (pathname), char* pathname)
{
	register char*	p;
	register char*	q;
	int	slash;

	/*
	 *	ŏ̋󔒃XLbv
	 */
	for (p = pathname; isspace(*p); p++)
		;

#if	defined(MSDOS) || defined(HUMAN68K)
	/*
	 *	hCuXLbv
	 */
	if (isalpha(*p) && *(p+1) == ':') {
		p += 2;
	}
#endif	/*defined(MSDOS) || defined(HUMAN68K)*/

	slash = ERROR_SLASH;
#ifdef	HUMAN68K
	if (q = getenv("SLASH")) {
		slash = *q;
	}
#endif	/*HUMAN68K*/

	if ((q = STRRCHR(p, slash)) == NULL) {
		q = p;
	}
	else {
		q++;
	}
#if	defined(MSDOS) || defined(HUMAN68K)
	/*
	 *	gq菜
	 */
	if (p = STRCHR(q, '.')) {
		*p = '\0';
	}
#endif
	return progname = q;
}


/*FUNC
static void	DEFUN(message, (type, fmt, ap), char* type AND char* fmt AND va_list ap)
	type	bZ[W^Cv
		fmt		o͂tH[}bgւ̃|C^
		ap		ϒXg

@\	WG[o͂ɃbZ[W\
ENDFUNC*/
static void	DEFUN(message, (type, fmt, ap), char* type AND char* fmt AND va_list ap)
{
	fputc('\n', stderr);
	if (progname) {
		fprintf(stderr, "%s: ", progname);
	}
	if (type) {
		fprintf(stderr, "%s: ", type);
	}
	if (fmt) {
		vfprintf(stderr, fmt, ap);
	}
	if (0 < errno && errno < sys_nerr) {
		fprintf(stderr, "(%s)", sys_errlist[errno]);
		errno = 0;
	}
	fputc('\n', stderr);
}


/*FUNC
void	DEFUN(msg, (fmt), char* fmt DOTS)
	fmt		o͂郁bZ[WtH[}bgւ̃|C^

@\	WG[o͂ɃbZ[W\

l	֐ message() ĂяoĂ
ENDFUNC*/
void	DEFUN(msg, (fmt), char* fmt DOTS)
{
	va_list	ap;

	va_start(ap, fmt);
	message(NULL, fmt, ap);
	va_end(ap);
}


/*FUNC
void	DEFUN(warning, (fmt), char* fmt DOTS)
	fmt		o͂郁bZ[WtH[}bgւ̃|C^

@\	WG[o͂Ƀ[jO\

l	֐ message() ĂяoĂ
ENDFUNC*/
void	DEFUN(warning, (fmt), char* fmt DOTS)
{
	va_list	ap;

	va_start(ap, fmt);
	message("WARNING", fmt, ap);
	va_end(ap);
}


/*FUNC
void	DEFUN(error, (fmt), char* fmt DOTS)
	fmt		o͂郁bZ[WtH[}bgւ̃|C^

@\	WG[o͂ɃG[\

l	֐ message() ĂяoĂ
ENDFUNC*/
void	DEFUN(error, (fmt), char* fmt DOTS)
{
	va_list	ap;

	va_start(ap, fmt);
	message("ERROR", fmt, ap);
	va_end(ap);
}


/*FUNC
VOLATILE void	DEFUN(fatal, (fmt), char* fmt DOTS)
	fmt		o͂郁bZ[WtH[}bgւ̃|C^

@\	WG[o͂ɃG[\AvOI

l	֐ message() ĂяoĂ
ENDFUNC*/
VOLATILE void	DEFUN(fatal, (fmt), char* fmt DOTS)
{
	int	err;
	va_list	ap;

	va_start(ap, fmt);
	err = errno;
	message("FATAL ERROR", fmt, ap);
	va_end(ap);
#ifndef	FATAL_TERM
	exit(err);
#else
	if (err) {
		term(err);
	}
	else {
		term(-1);
	}
#endif
}


