/*  This file is `NOT' GNU, error report to stderr library header.

    Copyright (C) 1993-95  씎Y(oo) <HGG00736@niftyserve.or.jp>
*/
#ifndef	_ERROR_H_
#define	_ERROR_H_	1

#ifdef	HAVE_MBSTRING_H
#include	<mbstring.h>
#define	STRCHR(s,c)		(char*)mbschr((CONST unsigned char*)s,c)
#define	STRRCHR(s,c)	(char*)mbsrchr((CONST unsigned char*)s,c)
#else
#ifdef	HAVE_JSTRING_H
#include	<jstring.h>
#define	STRCHR(s,c)		(char*)jstrchr((CONST unsigned char*)s,c)
#define	STRRCHR(s,c)	(char*)jstrrchr((CONST unsigned char*)s,c)
#else	/*!HAVE_JSTRING_H*/
#include	<string.h>
#define	STRCHR(s,c)		strchr(s,c)
#define	STRRCHR(s,c)	strrchr(s,c)
#endif	/*HAVE_JSTRING_H*/
#endif	/*HAVE_MBSTRING_H*/
#include	"ansidecl.h"

#ifdef	FATAL_TERM
extern VOLATILE void	EXFUN(term, (int code));
#endif	/*FATAL_TERM*/

#if	defined(MSDOS) || defined(HUMAN68K)
#define	ERROR_SLASH	'\\'
#else
#define	ERROR_SLASH	'/'
#endif

extern char*	EXFUN(set_progname, (char* pathname));
extern void	EXFUN(msg, (char* fmt DOTS));
extern void	EXFUN(warning, (char* fmt DOTS));
extern void	EXFUN(error, (char* fmt DOTS));
extern VOLATILE void	EXFUN(fatal, (char* fmt DOTS));

#endif	/*_ERROR_H_*/
